module win32.oleauto;

import win32.com.OAIDL;

extern(Windows) {
// ported from ....
//+---------------------------------------------------------------------------
//
//  Microsoft Windows
//  Copyright (C) Microsoft Corporation, 1992 - 1997.
//
//  File:       oleauto.h
//
//  Contents:   Defines Ole Automation support function prototypes, constants
//
//----------------------------------------------------------------------------


// Set packing to 8 for ISV, and Win95 support
//#include <pshpack8.h>

//  Definition of the OLE Automation APIs, and macros.


extern(C) IID IID_StdOle;

enum {
	STDOLE_MAJORVERNUM  =0x1,
	STDOLE_MINORVERNUM  =0x0,
	STDOLE_LCID         =0x0000,

	STDOLE2_MAJORVERNUM =0x2,
	STDOLE2_MINORVERNUM =0x0,
	STDOLE2_LCID        =0x0000
}

alias DWORD LCID;


/* pull in the MIDL generated header */


/*---------------------------------------------------------------------*/
/*                            BSTR API                                 */
/*---------------------------------------------------------------------*/

BSTR SysAllocString(OLECHAR *);
INT  SysReAllocString(BSTR *, OLECHAR *);
BSTR SysAllocStringLen(OLECHAR *, UINT);
INT  SysReAllocStringLen(BSTR *, OLECHAR *, UINT);
void SysFreeString(BSTR);
UINT SysStringLen(BSTR);

UINT SysStringByteLen(BSTR bstr);
BSTR SysAllocStringByteLen(LPCSTR psz, UINT len);

/*---------------------------------------------------------------------*/
/*                            Time API                                 */
/*---------------------------------------------------------------------*/

INT DosDateTimeToVariantTime(USHORT wDosDate, USHORT wDosTime, DOUBLE * pvtime);
INT VariantTimeToDosDateTime(DOUBLE vtime, USHORT * pwDosDate, USHORT * pwDosTime);

INT SystemTimeToVariantTime(LPSYSTEMTIME lpSystemTime, DOUBLE *pvtime);
INT VariantTimeToSystemTime(DOUBLE vtime, LPSYSTEMTIME lpSystemTime);


/*---------------------------------------------------------------------*/
/*                          SafeArray API                              */
/*---------------------------------------------------------------------*/

HRESULT SafeArrayAllocDescriptor(UINT cDims, SAFEARRAY ** ppsaOut);
HRESULT SafeArrayAllocDescriptorEx(VARTYPE vt, UINT cDims, SAFEARRAY ** ppsaOut);
HRESULT SafeArrayAllocData(SAFEARRAY * psa);
SAFEARRAY * SafeArrayCreate(VARTYPE vt, UINT cDims, SAFEARRAYBOUND * rgsabound);
SAFEARRAY * SafeArrayCreateEx(VARTYPE vt, UINT cDims, SAFEARRAYBOUND * rgsabound, PVOID pvExtra);
HRESULT SafeArrayCopyData(SAFEARRAY *psaSource, SAFEARRAY *psaTarget);
HRESULT SafeArrayDestroyDescriptor(SAFEARRAY * psa);
HRESULT SafeArrayDestroyData(SAFEARRAY * psa);
HRESULT SafeArrayDestroy(SAFEARRAY * psa);
HRESULT SafeArrayRedim(SAFEARRAY * psa, SAFEARRAYBOUND * psaboundNew);
UINT SafeArrayGetDim(SAFEARRAY * psa);
UINT SafeArrayGetElemsize(SAFEARRAY * psa);
HRESULT SafeArrayGetUBound(SAFEARRAY * psa, UINT nDim, LONG * plUbound);
HRESULT SafeArrayGetLBound(SAFEARRAY * psa, UINT nDim, LONG * plLbound);
HRESULT SafeArrayLock(SAFEARRAY * psa);
HRESULT SafeArrayUnlock(SAFEARRAY * psa);
HRESULT SafeArrayAccessData(SAFEARRAY * psa, void ** ppvData);
HRESULT SafeArrayUnaccessData(SAFEARRAY * psa);
HRESULT SafeArrayGetElement(SAFEARRAY * psa, LONG * rgIndices, void * pv);
HRESULT SafeArrayPutElement(SAFEARRAY * psa, LONG * rgIndices, void * pv);
HRESULT SafeArrayCopy(SAFEARRAY * psa, SAFEARRAY ** ppsaOut);
HRESULT SafeArrayPtrOfIndex(SAFEARRAY * psa, LONG * rgIndices, void ** ppvData);
HRESULT SafeArraySetRecordInfo(SAFEARRAY * psa, IRecordInfo  prinfo);
HRESULT SafeArrayGetRecordInfo(SAFEARRAY * psa, IRecordInfo * prinfo);
HRESULT SafeArraySetIID(SAFEARRAY * psa, REFGUID guid);
HRESULT SafeArrayGetIID(SAFEARRAY * psa, GUID * pguid);
HRESULT SafeArrayGetVartype(SAFEARRAY * psa, VARTYPE * pvt);
SAFEARRAY * SafeArrayCreateVector(VARTYPE vt, LONG lLbound, ULONG cElements);
SAFEARRAY * SafeArrayCreateVectorEx(VARTYPE vt, LONG lLbound, ULONG cElements, PVOID pvExtra);

/*---------------------------------------------------------------------*/
/*                           VARIANT API                               */
/*---------------------------------------------------------------------*/

void VariantInit(VARIANTARG * pvarg);
HRESULT VariantClear(VARIANTARG * pvarg);
HRESULT VariantCopy(VARIANTARG * pvargDest, VARIANTARG * pvargSrc);
HRESULT VariantCopyInd(VARIANT * pvarDest, VARIANTARG * pvargSrc);
HRESULT VariantChangeType(VARIANTARG * pvargDest,
                VARIANTARG * pvarSrc, USHORT wFlags, VARTYPE vt);
HRESULT VariantChangeTypeEx(VARIANTARG * pvargDest,
                VARIANTARG * pvarSrc, LCID lcid, USHORT wFlags, VARTYPE vt);

// Flags for VariantChangeType/VariantChangeTypeEx
enum {
	VARIANT_NOVALUEPROP      =0x01,
	VARIANT_ALPHABOOL        =0x02, // For VT_BOOL to VT_BSTR conversions,
                                      // convert to "True"/"False" instead of
                                      // "-1"/"0"
	VARIANT_NOUSEROVERRIDE   =0x04, // For conversions to/from VT_BSTR,
				      // passes LOCALE_NOUSEROVERRIDE
				      // to core coercion routines
	VARIANT_CALENDAR_HIJRI   =0x08,
	VARIANT_LOCALBOOL        =0x10 // For VT_BOOL to VT_BSTR and back,
                                      // convert to local language rather than
                                      // English
}

/*---------------------------------------------------------------------*/
/*                Vector <-> Bstr conversion APIs                      */
/*---------------------------------------------------------------------*/

HRESULT VectorFromBstr (BSTR bstr, SAFEARRAY ** ppsa);
HRESULT BstrFromVector (SAFEARRAY *psa, BSTR *pbstr);

/*---------------------------------------------------------------------*/
/*                     Variant API Flags                               */
/*---------------------------------------------------------------------*/

/* Any of the coersion functions that converts either from or to a string
 * takes an additional lcid and dwFlags arguments. The lcid argument allows
 * locale specific parsing to occur.  The dwFlags allow additional function
 * specific condition to occur.  All function that accept the dwFlags argument
 * can include either 0 or LOCALE_NOUSEROVERRIDE flag.
 */

/* The VarDateFromStr and VarBstrFromDate functions also accept the
 * VAR_TIMEVALUEONLY and VAR_DATEVALUEONLY flags
 */
enum : DWORD {
	VAR_TIMEVALUEONLY       =(cast(DWORD)0x00000001),    /* return time value */
	VAR_DATEVALUEONLY       =(cast(DWORD)0x00000002),    /* return date value */

/* VarDateFromUdate() only */
	VAR_VALIDDATE           =(cast(DWORD)0x00000004),

/* Accepted by all date & format APIs */
	VAR_CALENDAR_HIJRI      =(cast(DWORD)0x00000008),    /* use Hijri calender */

/* Booleans can optionally be accepted in localized form. Pass VAR_LOCALBOOL
 * into VarBoolFromStr and VarBstrFromBool to use localized boolean names
 */
	VAR_LOCALBOOL           =(cast(DWORD)0x00000010),

/* When passed into VarFormat and VarFormatFromTokens, prevents substitution
 * of formats in the case where a string is passed in that can not be
 * coverted into the desired type. (for ex, 'Format("Hello", "General Number")')
 */
	VAR_FORMAT_NOSUBSTITUTE =(cast(DWORD)0x00000020),

/*
 * For VarBstrFromDate only - forces years to be 4 digits rather than shortening
 * to 2-digits when the years is in the date window.
 */
	VAR_FOURDIGITYEARS	=(cast(DWORD)0x00000040)
}

/*---------------------------------------------------------------------*/
/*                     VARTYPE Coercion API                            */
/*---------------------------------------------------------------------*/

/* Note: The routines that convert *from* a string are defined
 * to take a OLECHAR* rather than a BSTR because no allocation is
 * required, and this makes the routines a bit more generic.
 * They may of course still be passed a BSTR as the strIn param.
 */

HRESULT  VarUI1FromI2(SHORT sIn, BYTE * pbOut);
HRESULT  VarUI1FromI4(LONG lIn, BYTE * pbOut);
HRESULT  VarUI1FromR4(FLOAT fltIn, BYTE * pbOut);
HRESULT  VarUI1FromR8(DOUBLE dblIn, BYTE * pbOut);
HRESULT  VarUI1FromCy(CY cyIn, BYTE * pbOut);
HRESULT  VarUI1FromDate(DATE dateIn, BYTE * pbOut);
HRESULT  VarUI1FromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, BYTE * pbOut);
HRESULT  VarUI1FromDisp(IDispatch * pdispIn, LCID lcid, BYTE * pbOut);
HRESULT  VarUI1FromBool(VARIANT_BOOL boolIn, BYTE * pbOut);
HRESULT  VarUI1FromI1(CHAR cIn, BYTE *pbOut);
HRESULT  VarUI1FromUI2(USHORT uiIn, BYTE *pbOut);
HRESULT  VarUI1FromUI4(ULONG ulIn, BYTE *pbOut);
HRESULT  VarUI1FromDec(DECIMAL *pdecIn, BYTE *pbOut);

HRESULT  VarI2FromUI1(BYTE bIn, SHORT * psOut);
HRESULT  VarI2FromI4(LONG lIn, SHORT * psOut);
HRESULT  VarI2FromR4(FLOAT fltIn, SHORT * psOut);
HRESULT  VarI2FromR8(DOUBLE dblIn, SHORT * psOut);
HRESULT  VarI2FromCy(CY cyIn, SHORT * psOut);
HRESULT  VarI2FromDate(DATE dateIn, SHORT * psOut);
HRESULT  VarI2FromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, SHORT * psOut);
HRESULT  VarI2FromDisp(IDispatch * pdispIn, LCID lcid, SHORT * psOut);
HRESULT  VarI2FromBool(VARIANT_BOOL boolIn, SHORT * psOut);
HRESULT  VarI2FromI1(CHAR cIn, SHORT *psOut);
HRESULT  VarI2FromUI2(USHORT uiIn, SHORT *psOut);
HRESULT  VarI2FromUI4(ULONG ulIn, SHORT *psOut);
HRESULT  VarI2FromDec(DECIMAL *pdecIn, SHORT *psOut);

HRESULT  VarI4FromUI1(BYTE bIn, LONG * plOut);
HRESULT  VarI4FromI2(SHORT sIn, LONG * plOut);
HRESULT  VarI4FromR4(FLOAT fltIn, LONG * plOut);
HRESULT  VarI4FromR8(DOUBLE dblIn, LONG * plOut);
HRESULT  VarI4FromCy(CY cyIn, LONG * plOut);
HRESULT  VarI4FromDate(DATE dateIn, LONG * plOut);
HRESULT  VarI4FromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, LONG * plOut);
HRESULT  VarI4FromDisp(IDispatch * pdispIn, LCID lcid, LONG * plOut);
HRESULT  VarI4FromBool(VARIANT_BOOL boolIn, LONG * plOut);
HRESULT  VarI4FromI1(CHAR cIn, LONG *plOut);
HRESULT  VarI4FromUI2(USHORT uiIn, LONG *plOut);
HRESULT  VarI4FromUI4(ULONG ulIn, LONG *plOut);
HRESULT  VarI4FromDec(DECIMAL *pdecIn, LONG *plOut);
HRESULT  VarI4FromInt(INT intIn, LONG *plOut);

HRESULT  VarR4FromUI1(BYTE bIn, FLOAT * pfltOut);
HRESULT  VarR4FromI2(SHORT sIn, FLOAT * pfltOut);
HRESULT  VarR4FromI4(LONG lIn, FLOAT * pfltOut);
HRESULT  VarR4FromR8(DOUBLE dblIn, FLOAT * pfltOut);
HRESULT  VarR4FromCy(CY cyIn, FLOAT * pfltOut);
HRESULT  VarR4FromDate(DATE dateIn, FLOAT * pfltOut);
HRESULT  VarR4FromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, FLOAT *pfltOut);
HRESULT  VarR4FromDisp(IDispatch * pdispIn, LCID lcid, FLOAT * pfltOut);
HRESULT  VarR4FromBool(VARIANT_BOOL boolIn, FLOAT * pfltOut);
HRESULT  VarR4FromI1(CHAR cIn, FLOAT *pfltOut);
HRESULT  VarR4FromUI2(USHORT uiIn, FLOAT *pfltOut);
HRESULT  VarR4FromUI4(ULONG ulIn, FLOAT *pfltOut);
HRESULT  VarR4FromDec(DECIMAL *pdecIn, FLOAT *pfltOut);

HRESULT  VarR8FromUI1(BYTE bIn, DOUBLE * pdblOut);
HRESULT  VarR8FromI2(SHORT sIn, DOUBLE * pdblOut);
HRESULT  VarR8FromI4(LONG lIn, DOUBLE * pdblOut);
HRESULT  VarR8FromR4(FLOAT fltIn, DOUBLE * pdblOut);
HRESULT  VarR8FromCy(CY cyIn, DOUBLE * pdblOut);
HRESULT  VarR8FromDate(DATE dateIn, DOUBLE * pdblOut);
HRESULT  VarR8FromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, DOUBLE *pdblOut);
HRESULT  VarR8FromDisp(IDispatch * pdispIn, LCID lcid, DOUBLE * pdblOut);
HRESULT  VarR8FromBool(VARIANT_BOOL boolIn, DOUBLE * pdblOut);
HRESULT  VarR8FromI1(CHAR cIn, DOUBLE *pdblOut);
HRESULT  VarR8FromUI2(USHORT uiIn, DOUBLE *pdblOut);
HRESULT  VarR8FromUI4(ULONG ulIn, DOUBLE *pdblOut);
HRESULT  VarR8FromDec(DECIMAL *pdecIn, DOUBLE *pdblOut);

HRESULT  VarDateFromUI1(BYTE bIn, DATE * pdateOut);
HRESULT  VarDateFromI2(SHORT sIn, DATE * pdateOut);
HRESULT  VarDateFromI4(LONG lIn, DATE * pdateOut);
HRESULT  VarDateFromR4(FLOAT fltIn, DATE * pdateOut);
HRESULT  VarDateFromR8(DOUBLE dblIn, DATE * pdateOut);
HRESULT  VarDateFromCy(CY cyIn, DATE * pdateOut);
HRESULT  VarDateFromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, DATE *pdateOut);
HRESULT  VarDateFromDisp(IDispatch * pdispIn, LCID lcid, DATE * pdateOut);
HRESULT  VarDateFromBool(VARIANT_BOOL boolIn, DATE * pdateOut);
HRESULT  VarDateFromI1(CHAR cIn, DATE *pdateOut);
HRESULT  VarDateFromUI2(USHORT uiIn, DATE *pdateOut);
HRESULT  VarDateFromUI4(ULONG ulIn, DATE *pdateOut);
HRESULT  VarDateFromDec(DECIMAL *pdecIn, DATE *pdateOut);

HRESULT  VarCyFromUI1(BYTE bIn, CY * pcyOut);
HRESULT  VarCyFromI2(SHORT sIn, CY * pcyOut);
HRESULT  VarCyFromI4(LONG lIn, CY * pcyOut);
HRESULT  VarCyFromR4(FLOAT fltIn, CY * pcyOut);
HRESULT  VarCyFromR8(DOUBLE dblIn, CY * pcyOut);
HRESULT  VarCyFromDate(DATE dateIn, CY * pcyOut);
HRESULT  VarCyFromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, CY * pcyOut);
HRESULT  VarCyFromDisp(IDispatch * pdispIn, LCID lcid, CY * pcyOut);
HRESULT  VarCyFromBool(VARIANT_BOOL boolIn, CY * pcyOut);
HRESULT  VarCyFromI1(CHAR cIn, CY *pcyOut);
HRESULT  VarCyFromUI2(USHORT uiIn, CY *pcyOut);
HRESULT  VarCyFromUI4(ULONG ulIn, CY *pcyOut);
HRESULT  VarCyFromDec(DECIMAL *pdecIn, CY *pcyOut);

HRESULT  VarBstrFromUI1(BYTE bVal, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromI2(SHORT iVal, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromI4(LONG lIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromR4(FLOAT fltIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromR8(DOUBLE dblIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromCy(CY cyIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromDate(DATE dateIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromDisp(IDispatch * pdispIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromBool(VARIANT_BOOL boolIn, LCID lcid, ULONG dwFlags, BSTR * pbstrOut);
HRESULT  VarBstrFromI1(CHAR cIn, LCID lcid, ULONG dwFlags, BSTR *pbstrOut);
HRESULT  VarBstrFromUI2(USHORT uiIn, LCID lcid, ULONG dwFlags, BSTR *pbstrOut);
HRESULT  VarBstrFromUI4(ULONG ulIn, LCID lcid, ULONG dwFlags, BSTR *pbstrOut);
HRESULT  VarBstrFromDec(DECIMAL *pdecIn, LCID lcid, ULONG dwFlags, BSTR *pbstrOut);

HRESULT  VarBoolFromUI1(BYTE bIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromI2(SHORT sIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromI4(LONG lIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromR4(FLOAT fltIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromR8(DOUBLE dblIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromDate(DATE dateIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromCy(CY cyIn, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromDisp(IDispatch * pdispIn, LCID lcid, VARIANT_BOOL * pboolOut);
HRESULT  VarBoolFromI1(CHAR cIn, VARIANT_BOOL *pboolOut);
HRESULT VarBoolFromUI2(USHORT uiIn, VARIANT_BOOL *pboolOut);
HRESULT  VarBoolFromUI4(ULONG ulIn, VARIANT_BOOL *pboolOut);
HRESULT  VarBoolFromDec(DECIMAL *pdecIn, VARIANT_BOOL *pboolOut);

HRESULT  VarI1FromUI1(BYTE bIn, CHAR *pcOut);
HRESULT  VarI1FromI2(SHORT uiIn, CHAR *pcOut);
HRESULT  VarI1FromI4(LONG lIn, CHAR *pcOut);
HRESULT  VarI1FromR4(FLOAT fltIn, CHAR *pcOut);
HRESULT  VarI1FromR8(DOUBLE dblIn, CHAR *pcOut);
HRESULT  VarI1FromDate(DATE dateIn, CHAR *pcOut);
HRESULT  VarI1FromCy(CY cyIn, CHAR *pcOut);
HRESULT  VarI1FromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, CHAR *pcOut);
HRESULT  VarI1FromDisp(IDispatch *pdispIn, LCID lcid, CHAR *pcOut);
HRESULT  VarI1FromBool(VARIANT_BOOL boolIn, CHAR *pcOut);
HRESULT  VarI1FromUI2(USHORT uiIn, CHAR *pcOut);
HRESULT  VarI1FromUI4(ULONG ulIn, CHAR *pcOut);
HRESULT  VarI1FromDec(DECIMAL *pdecIn, CHAR *pcOut);

HRESULT  VarUI2FromUI1(BYTE bIn, USHORT *puiOut);
HRESULT  VarUI2FromI2(SHORT uiIn, USHORT *puiOut);
HRESULT  VarUI2FromI4(LONG lIn, USHORT *puiOut);
HRESULT  VarUI2FromR4(FLOAT fltIn, USHORT *puiOut);
HRESULT  VarUI2FromR8(DOUBLE dblIn, USHORT *puiOut);
HRESULT  VarUI2FromDate(DATE dateIn, USHORT *puiOut);
HRESULT  VarUI2FromCy(CY cyIn, USHORT *puiOut);
HRESULT  VarUI2FromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, USHORT *puiOut);
HRESULT  VarUI2FromDisp(IDispatch *pdispIn, LCID lcid, USHORT *puiOut);
HRESULT  VarUI2FromBool(VARIANT_BOOL boolIn, USHORT *puiOut);
HRESULT  VarUI2FromI1(CHAR cIn, USHORT *puiOut);
HRESULT  VarUI2FromUI4(ULONG ulIn, USHORT *puiOut);
HRESULT  VarUI2FromDec(DECIMAL *pdecIn, USHORT *puiOut);

HRESULT  VarUI4FromUI1(BYTE bIn, ULONG *pulOut);
HRESULT  VarUI4FromI2(SHORT uiIn, ULONG *pulOut);
HRESULT  VarUI4FromI4(LONG lIn, ULONG *pulOut);
HRESULT  VarUI4FromR4(FLOAT fltIn, ULONG *pulOut);
HRESULT  VarUI4FromR8(DOUBLE dblIn, ULONG *pulOut);
HRESULT  VarUI4FromDate(DATE dateIn, ULONG *pulOut);
HRESULT  VarUI4FromCy(CY cyIn, ULONG *pulOut);
HRESULT  VarUI4FromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, ULONG *pulOut);
HRESULT  VarUI4FromDisp(IDispatch *pdispIn, LCID lcid, ULONG *pulOut);
HRESULT  VarUI4FromBool(VARIANT_BOOL boolIn, ULONG *pulOut);
HRESULT  VarUI4FromI1(CHAR cIn, ULONG *pulOut);
HRESULT  VarUI4FromUI2(USHORT uiIn, ULONG *pulOut);
HRESULT  VarUI4FromDec(DECIMAL *pdecIn, ULONG *pulOut);

HRESULT  VarDecFromUI1(BYTE bIn, DECIMAL *pdecOut);
HRESULT  VarDecFromI2(SHORT uiIn, DECIMAL *pdecOut);
HRESULT  VarDecFromI4(LONG lIn, DECIMAL *pdecOut);
HRESULT  VarDecFromR4(FLOAT fltIn, DECIMAL *pdecOut);
HRESULT  VarDecFromR8(DOUBLE dblIn, DECIMAL *pdecOut);
HRESULT  VarDecFromDate(DATE dateIn, DECIMAL *pdecOut);
HRESULT  VarDecFromCy(CY cyIn, DECIMAL *pdecOut);
HRESULT  VarDecFromStr(OLECHAR *strIn, LCID lcid, ULONG dwFlags, DECIMAL *pdecOut);
HRESULT  VarDecFromDisp(IDispatch *pdispIn, LCID lcid, DECIMAL *pdecOut);
HRESULT  VarDecFromBool(VARIANT_BOOL boolIn, DECIMAL *pdecOut);
HRESULT  VarDecFromI1(CHAR cIn, DECIMAL *pdecOut);
HRESULT  VarDecFromUI2(USHORT uiIn, DECIMAL *pdecOut);
HRESULT  VarDecFromUI4(ULONG ulIn, DECIMAL *pdecOut);

/*  these are alias do to later
#define VarUI4FromUI4(in, pOut) (*(pOut) = (in))
#define VarI4FromI4(in, pOut)   (*(pOut) = (in))

#define VarUI1FromInt       VarUI1FromI4
#define VarUI1FromUint      VarUI1FromUI4
#define VarI2FromInt        VarI2FromI4
#define VarI2FromUint       VarI2FromUI4
#define VarI4FromInt        VarI4FromI4
#define VarI4FromUint       VarI4FromUI4
#define VarR4FromInt        VarR4FromI4
#define VarR4FromUint       VarR4FromUI4
#define VarR8FromInt        VarR8FromI4
#define VarR8FromUint       VarR8FromUI4
#define VarDateFromInt      VarDateFromI4
#define VarDateFromUint     VarDateFromUI4
#define VarCyFromInt        VarCyFromI4
#define VarCyFromUint       VarCyFromUI4
#define VarBstrFromInt      VarBstrFromI4
#define VarBstrFromUint     VarBstrFromUI4
#define VarBoolFromInt      VarBoolFromI4
#define VarBoolFromUint     VarBoolFromUI4
#define VarI1FromInt        VarI1FromI4
#define VarI1FromUint       VarI1FromUI4
#define VarUI2FromInt       VarUI2FromI4
#define VarUI2FromUint      VarUI2FromUI4
#define VarUI4FromInt       VarUI4FromI4
#define VarUI4FromUint      VarUI4FromUI4
#define VarDecFromInt       VarDecFromI4
#define VarDecFromUint      VarDecFromUI4
#define VarIntFromUI1       VarI4FromUI1
#define VarIntFromI2        VarI4FromI2
#define VarIntFromI4        VarI4FromI4
#define VarIntFromR4        VarI4FromR4
#define VarIntFromR8        VarI4FromR8
#define VarIntFromDate      VarI4FromDate
#define VarIntFromCy        VarI4FromCy
#define VarIntFromStr       VarI4FromStr
#define VarIntFromDisp      VarI4FromDisp
#define VarIntFromBool      VarI4FromBool
#define VarIntFromI1        VarI4FromI1
#define VarIntFromUI2       VarI4FromUI2
#define VarIntFromUI4       VarI4FromUI4
#define VarIntFromDec       VarI4FromDec
#define VarIntFromUint      VarI4FromUI4
#define VarUintFromUI1      VarUI4FromUI1
#define VarUintFromI2       VarUI4FromI2
#define VarUintFromI4       VarUI4FromI4
#define VarUintFromR4       VarUI4FromR4
#define VarUintFromR8       VarUI4FromR8
#define VarUintFromDate     VarUI4FromDate
#define VarUintFromCy       VarUI4FromCy
#define VarUintFromStr      VarUI4FromStr
#define VarUintFromDisp     VarUI4FromDisp
#define VarUintFromBool     VarUI4FromBool
#define VarUintFromI1       VarUI4FromI1
#define VarUintFromUI2      VarUI4FromUI2
#define VarUintFromUI4      VarUI4FromUI4
#define VarUintFromDec      VarUI4FromDec
#define VarUintFromInt      VarUI4FromI4
*/

/* Mac Note: On the Mac, the coersion functions support the
 * Symantec C++ calling convention for float/double. To support
 * float/double arguments compiled with the MPW C compiler,
 * use the following APIs to move MPW float/double values into
 * a VARIANT.
 */

/*---------------------------------------------------------------------*/
/*            New VARIANT <-> string parsing functions                 */
/*---------------------------------------------------------------------*/

struct NUMPARSE { align(8):
    INT   cDig;
    ULONG dwInFlags;
    ULONG dwOutFlags;
    INT   cchUsed;
    INT   nBaseShift;
    INT   nPwr10;
}

/* flags used by both dwInFlags and dwOutFlags:
 */
enum {
NUMPRS_LEADING_WHITE    =0x0001,
NUMPRS_TRAILING_WHITE   =0x0002,
NUMPRS_LEADING_PLUS     =0x0004,
NUMPRS_TRAILING_PLUS    =0x0008,
NUMPRS_LEADING_MINUS    =0x0010,
NUMPRS_TRAILING_MINUS   =0x0020,
NUMPRS_HEX_OCT          =0x0040,
NUMPRS_PARENS           =0x0080,
NUMPRS_DECIMAL          =0x0100,
NUMPRS_THOUSANDS        =0x0200,
NUMPRS_CURRENCY         =0x0400,
NUMPRS_EXPONENT         =0x0800,
NUMPRS_USE_ALL          =0x1000,
NUMPRS_STD              =0x1FFF,
/* flags used by dwOutFlags only:
 */
NUMPRS_NEG              =0x10000,
NUMPRS_INEXACT          =0x20000
}

/* flags used by VarNumFromParseNum to indicate acceptable result types:
 */
enum {
VTBIT_I1        =(1 << VT_I1),
VTBIT_UI1       =(1 << VT_UI1),
VTBIT_I2        =(1 << VT_I2),
VTBIT_UI2       =(1 << VT_UI2),
VTBIT_I4        =(1 << VT_I4),
VTBIT_UI4       =(1 << VT_UI4),
VTBIT_R4        =(1 << VT_R4),
VTBIT_R8        =(1 << VT_R8),
VTBIT_CY        =(1 << VT_CY),
VTBIT_DECIMAL   =(1 << VT_DECIMAL)
}

HRESULT VarParseNumFromStr(OLECHAR * strIn, LCID lcid, ULONG dwFlags,
            NUMPARSE * pnumprs, BYTE * rgbDig);

HRESULT VarNumFromParseNum(NUMPARSE * pnumprs, BYTE * rgbDig,
            ULONG dwVtBits, VARIANT * pvar);

/*---------------------------------------------------------------------*/
/*                     VARTYPE Math API                                */
/*---------------------------------------------------------------------*/

HRESULT VarAdd(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarAnd(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarCat(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarDiv(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarEqv(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarIdiv(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarImp(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarMod(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarMul(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarOr(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarPow(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarSub(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);
HRESULT VarXor(LPVARIANT pvarLeft, LPVARIANT pvarRight, LPVARIANT pvarResult);

HRESULT VarAbs(LPVARIANT pvarIn, LPVARIANT pvarResult);
HRESULT VarFix(LPVARIANT pvarIn, LPVARIANT pvarResult);
HRESULT VarInt(LPVARIANT pvarIn, LPVARIANT pvarResult);
HRESULT VarNeg(LPVARIANT pvarIn, LPVARIANT pvarResult);
HRESULT VarNot(LPVARIANT pvarIn, LPVARIANT pvarResult);

HRESULT VarRound(LPVARIANT pvarIn, int cDecimals, LPVARIANT pvarResult);

// dwFlags passed to CompareString if a string compare
HRESULT VarCmp(LPVARIANT pvarLeft, LPVARIANT pvarRight, LCID lcid, ULONG dwFlags);


// Decimal math
//
HRESULT VarDecAdd(LPDECIMAL pdecLeft, LPDECIMAL pdecRight, LPDECIMAL pdecResult);
HRESULT VarDecDiv(LPDECIMAL pdecLeft, LPDECIMAL pdecRight, LPDECIMAL pdecResult);
HRESULT VarDecMul(LPDECIMAL pdecLeft, LPDECIMAL pdecRight, LPDECIMAL pdecResult);
HRESULT VarDecSub(LPDECIMAL pdecLeft, LPDECIMAL pdecRight, LPDECIMAL pdecResult);

HRESULT VarDecAbs(LPDECIMAL pdecIn, LPDECIMAL pdecResult);
HRESULT VarDecFix(LPDECIMAL pdecIn, LPDECIMAL pdecResult);
HRESULT VarDecInt(LPDECIMAL pdecIn, LPDECIMAL pdecResult);
HRESULT VarDecNeg(LPDECIMAL pdecIn, LPDECIMAL pdecResult);

HRESULT VarDecRound(LPDECIMAL pdecIn, int cDecimals, LPDECIMAL pdecResult);

HRESULT VarDecCmp(LPDECIMAL pdecLeft, LPDECIMAL pdecRight);
HRESULT VarDecCmpR8(LPDECIMAL pdecLeft, double dblRight);


// Currency math
//
HRESULT VarCyAdd(CY cyLeft, CY cyRight, LPCY pcyResult);
HRESULT VarCyMul(CY cyLeft, CY cyRight, LPCY pcyResult);
HRESULT VarCyMulI4(CY cyLeft, long lRight, LPCY pcyResult);
HRESULT VarCySub(CY cyLeft, CY cyRight, LPCY pcyResult);

HRESULT VarCyAbs(CY cyIn, LPCY pcyResult);
HRESULT VarCyFix(CY cyIn, LPCY pcyResult);
HRESULT VarCyInt(CY cyIn, LPCY pcyResult);
HRESULT VarCyNeg(CY cyIn, LPCY pcyResult);

HRESULT VarCyRound(CY cyIn, int cDecimals, LPCY pcyResult);

HRESULT VarCyCmp(CY cyLeft, CY cyRight);
HRESULT VarCyCmpR8(CY cyLeft, double dblRight);


// Misc support functions
//
HRESULT VarBstrCat(BSTR bstrLeft, BSTR bstrRight, LPBSTR pbstrResult);
HRESULT VarBstrCmp(BSTR bstrLeft, BSTR bstrRight, LCID lcid, ULONG dwFlags); // dwFlags passed to CompareString
HRESULT VarR8Pow(double dblLeft, double dblRight, double *pdblResult);
HRESULT VarR4CmpR8(float fltLeft, double dblRight);
HRESULT VarR8Round(double dblIn, int cDecimals, double *pdblResult);


// Compare results.  These are returned as a SUCCESS HResult.  Subtracting
// one gives the usual values of -1 for Less Than, 0 for Equal To, +1 for
// Greater Than.
//
enum {
VARCMP_LT   =0,
VARCMP_EQ   =1,
VARCMP_GT   =2,
VARCMP_NULL =3
}

// VT_HARDTYPE tells the compare routine that the argument is a literal or
// otherwise declared of that specific type.  It causes comparison rules to 
// change. For example, if a hard-type string is compared to a variant (not hard
// -type) number, the number is converted to string.  If a hard-type number is 
// compared to a variant string, the string is converted to number.  If they're 
// both variant, then number < string.
alias VT_RESERVED VT_HARDTYPE ;

/*---------------------------------------------------------------------*/
/*                   New date functions                                */
/*---------------------------------------------------------------------*/

/* The UDATE structure is used with VarDateFromUdate() and VarUdateFromDate().
 * It represents an "unpacked date".
 */
struct UDATE { align(8):
    SYSTEMTIME st;
    USHORT  wDayOfYear;
}

/* APIs to "pack" and "unpack" dates.
 * NOTE: Ex version of VarDateFromUdate obeys 2 digit year setting in
 * control panel.
 */
HRESULT VarDateFromUdate(UDATE *pudateIn, ULONG dwFlags, DATE *pdateOut);
HRESULT VarDateFromUdateEx(UDATE *pudateIn, LCID lcid, ULONG dwFlags, DATE *pdateOut);
HRESULT VarUdateFromDate(DATE dateIn, ULONG dwFlags, UDATE *pudateOut);

/* API to retrieve the secondary(altername) month names
   Useful for Hijri, Polish and Russian alternate month names
*/   
HRESULT GetAltMonthNames(LCID lcid, LPOLESTR * * prgp);

/*---------------------------------------------------------------------*/
/*                 Format                                              */
/*---------------------------------------------------------------------*/

HRESULT VarFormat(LPVARIANT pvarIn, LPOLESTR pstrFormat, int iFirstDay, int iFirstWeek, ULONG dwFlags, BSTR *pbstrOut);
HRESULT VarFormatDateTime(LPVARIANT pvarIn, int iNamedFormat, ULONG dwFlags, BSTR *pbstrOut);
HRESULT VarFormatNumber(LPVARIANT pvarIn, int iNumDig, int iIncLead, int iUseParens, int iGroup, ULONG dwFlags, BSTR *pbstrOut);
HRESULT VarFormatPercent(LPVARIANT pvarIn, int iNumDig, int iIncLead, int iUseParens, int iGroup, ULONG dwFlags, BSTR *pbstrOut);
HRESULT VarFormatCurrency(LPVARIANT pvarIn, int iNumDig, int iIncLead, int iUseParens, int iGroup, ULONG dwFlags, BSTR *pbstrOut);

HRESULT VarWeekdayName(int iWeekday, int fAbbrev, int iFirstDay, ULONG dwFlags, BSTR *pbstrOut);
HRESULT VarMonthName(int iMonth, int fAbbrev, ULONG dwFlags, BSTR *pbstrOut);

HRESULT VarFormatFromTokens(LPVARIANT pvarIn, LPOLESTR pstrFormat, LPBYTE pbTokCur, ULONG dwFlags, BSTR *pbstrOut, LCID lcid);
HRESULT VarTokenizeFormatString(LPOLESTR pstrFormat, LPBYTE rgbTok, int cbTok, int iFirstDay, int iFirstWeek, LCID lcid, int *pcbActual);

/*---------------------------------------------------------------------*/
/*                 ITypeLib                                            */
/*---------------------------------------------------------------------*/

alias ITypeLib  LPTYPELIB;


/*---------------------------------------------------------------------*/
/*                ITypeInfo                                            */
/*---------------------------------------------------------------------*/


alias LONG DISPID;
alias DISPID MEMBERID;

alias DISPID_UNKNOWN MEMBERID_NIL;
enum {
	ID_DEFAULTINST  = -2
}


/* Flags for IDispatch::Invoke */
enum {
DISPATCH_METHOD         =0x1,
DISPATCH_PROPERTYGET    =0x2,
DISPATCH_PROPERTYPUT    =0x4,
DISPATCH_PROPERTYPUTREF =0x8
}

alias ITypeInfo LPTYPEINFO;


/*---------------------------------------------------------------------*/
/*                ITypeComp                                            */
/*---------------------------------------------------------------------*/

alias ITypeComp LPTYPECOMP;


/*---------------------------------------------------------------------*/
/*             ICreateTypeLib                                          */
/*---------------------------------------------------------------------*/

alias ICreateTypeLib  LPCREATETYPELIB;

alias ICreateTypeInfo LPCREATETYPEINFO;

/*---------------------------------------------------------------------*/
/*             TypeInfo API                                            */
/*---------------------------------------------------------------------*/

/* compute a 16bit hash value for the given name
 */
ULONG LHashValOfNameSysA(SYSKIND syskind, LCID lcid, LPCSTR szName);

ULONG LHashValOfNameSys(SYSKIND syskind, LCID lcid, OLECHAR * szName);

/*
#define LHashValOfName(lcid, szName) \
            LHashValOfNameSys(SYS_WIN32, lcid, szName)

#define WHashValOfLHashVal(lhashval) \
            ((USHORT) (0x0000ffff & (lhashval)))

#define IsHashValCompatible(lhashval1, lhashval2) \
            ((BOOL) ((0x00ff0000 & (lhashval1)) == (0x00ff0000 & (lhashval2))))
*/

/* load the typelib from the file with the given filename
 */
HRESULT  LoadTypeLib( OLECHAR  *szFile, ITypeLib * pptlib);

/* Control how a type library is registered
 */
enum REGKIND
{
    REGKIND_DEFAULT,
    REGKIND_REGISTER,
    REGKIND_NONE,
    DEFAULT  = REGKIND_DEFAULT,
    REGISTER = REGKIND_REGISTER,
    NONE     = REGKIND_NONE
}

HRESULT LoadTypeLibEx(LPCOLESTR szFile, REGKIND regkind,
            ITypeLib * pptlib);

/* load registered typelib
 */
HRESULT LoadRegTypeLib(REFGUID rguid, WORD wVerMajor, WORD wVerMinor,
            LCID lcid, ITypeLib * pptlib);

/* get path to registered typelib
 */
HRESULT QueryPathOfRegTypeLib(REFGUID guid, USHORT wMaj, USHORT wMin,
            LCID lcid, LPBSTR lpbstrPathName);

/* add typelib to registry
 */
HRESULT RegisterTypeLib(ITypeLib * ptlib, OLECHAR  *szFullPath,
            OLECHAR  *szHelpDir);

/* remove typelib from registry
 */

HRESULT UnRegisterTypeLib(REFGUID libID, WORD wVerMajor,
            WORD wVerMinor, LCID lcid, SYSKIND syskind);

HRESULT CreateTypeLib(SYSKIND syskind,  OLECHAR  *szFile,
            ICreateTypeLib * ppctlib);

HRESULT CreateTypeLib2(SYSKIND syskind, LPCOLESTR szFile,
            ICreateTypeLib2 *ppctlib);


/*---------------------------------------------------------------------*/
/*           IDispatch implementation support                          */
/*---------------------------------------------------------------------*/

alias IDispatch  LPDISPATCH;

struct PARAMDATA { align(8):
    OLECHAR * szName;   /* parameter name */
    VARTYPE vt;         /* parameter type */
} 
alias PARAMDATA * LPPARAMDATA;

struct METHODDATA {align(8):
    OLECHAR * szName;   /* method name */
    PARAMDATA * ppdata; /* pointer to an array of PARAMDATAs */
    DISPID dispid;      /* method ID */
    UINT iMeth;         /* method index */
    CALLCONV cc;        /* calling convention */
    UINT cArgs;         /* count of arguments */
    WORD wFlags;        /* same wFlags as on IDispatch::Invoke() */
    VARTYPE vtReturn;
} 
alias METHODDATA * LPMETHODDATA;

struct INTERFACEDATA {align(8):
    METHODDATA * pmethdata;  /* pointer to an array of METHODDATAs */
    UINT cMembers;      /* count of members */
} 
alias INTERFACEDATA * LPINTERFACEDATA;



/* Locate the parameter indicated by the given position, and
 * return it coerced to the given target VARTYPE (vtTarg).
 */
HRESULT DispGetParam(DISPPARAMS * pdispparams, UINT position,
            VARTYPE vtTarg, VARIANT * pvarResult, UINT * puArgErr);

/* Automatic TypeInfo driven implementation of IDispatch::GetIDsOfNames()
 */
HRESULT DispGetIDsOfNames(ITypeInfo  ptinfo, OLECHAR ** rgszNames,
            UINT cNames, DISPID * rgdispid);

/* Automatic TypeInfo driven implementation of IDispatch::Invoke()
 */
HRESULT DispInvoke(void * _this, ITypeInfo  ptinfo, DISPID dispidMember,
            WORD wFlags, DISPPARAMS * pparams, VARIANT * pvarResult,
            EXCEPINFO * pexcepinfo, UINT * puArgErr);

/* Construct a TypeInfo from an interface data description
 */
HRESULT CreateDispTypeInfo(INTERFACEDATA * pidata, LCID lcid,
            ITypeInfo * pptinfo);

/* Create an instance of the standard TypeInfo driven IDispatch
 * implementation.
 */
HRESULT CreateStdDispatch(IUnknown  punkOuter, void * pvThis,
            ITypeInfo  ptinfo, IUnknown * ppunkStdDisp);

/* Low-level helper for IDispatch::Invoke() provides machine independence
 * for customized Invoke().
 */
HRESULT DispCallFunc(void * pvInstance, ULONG oVft, CALLCONV cc,
            VARTYPE vtReturn, UINT  cActuals, VARTYPE * prgvt,
            VARIANTARG ** prgpvarg, VARIANT * pvargResult);


/*---------------------------------------------------------------------*/
/*            Active Object Registration API                           */
/*---------------------------------------------------------------------*/

/* flags for RegisterActiveObject */
enum {
ACTIVEOBJECT_STRONG =0x0,
ACTIVEOBJECT_WEAK =0x1
}

HRESULT RegisterActiveObject(IUnknown  punk, REFCLSID rclsid,
            DWORD dwFlags, DWORD * pdwRegister);

HRESULT RevokeActiveObject(DWORD dwRegister, void * pvReserved);

HRESULT GetActiveObject(REFCLSID rclsid, void * pvReserved,
            IUnknown * ppunk);

/*---------------------------------------------------------------------*/
/*                           ErrorInfo API                             */
/*---------------------------------------------------------------------*/

HRESULT SetErrorInfo(ULONG dwReserved, IErrorInfo  perrinfo);
HRESULT GetErrorInfo(ULONG dwReserved, IErrorInfo * pperrinfo);
HRESULT CreateErrorInfo(ICreateErrorInfo * pperrinfo);

/*---------------------------------------------------------------------*/
/*           User Defined Data types support                           */
/*---------------------------------------------------------------------*/

HRESULT GetRecordInfoFromTypeInfo(ITypeInfo  pTypeInfo,
            IRecordInfo * ppRecInfo);

HRESULT GetRecordInfoFromGuids(REFGUID rGuidTypeLib,
            ULONG uVerMajor, ULONG uVerMinor, LCID lcid,
            REFGUID rGuidTypeInfo, IRecordInfo * ppRecInfo);

/*---------------------------------------------------------------------*/
/*                           MISC API                                  */
/*---------------------------------------------------------------------*/

ULONG OaBuildVersion();

void ClearCustData(LPCUSTDATA pCustData);

// Declare variant access functions.
/*
#if __STDC__ || defined(NONAMELESSUNION)
#define V_UNION(X, Y)   ((X)->n1.n2.n3.Y)
#define V_VT(X)         ((X)->n1.n2.vt)
#define V_RECORDINFO(X) ((X)->n1.n2.n3.brecVal.pRecInfo)
#define V_RECORD(X)     ((X)->n1.n2.n3.brecVal.pvRecord)
#else
#define V_UNION(X, Y)   ((X)->Y)
#define V_VT(X)         ((X)->vt)
#define V_RECORDINFO(X) ((X)->pRecInfo)
#define V_RECORD(X)     ((X)->pvRecord)
#endif
*/

/* Variant access macros
 */
 /*
#define V_ISBYREF(X)     (V_VT(X)&VT_BYREF)
#define V_ISARRAY(X)     (V_VT(X)&VT_ARRAY)
#define V_ISVECTOR(X)    (V_VT(X)&VT_VECTOR)
#define V_NONE(X)        V_I2(X)

#define V_UI1(X)         V_UNION(X, bVal)
#define V_UI1REF(X)      V_UNION(X, pbVal)
#define V_I2(X)          V_UNION(X, iVal)
#define V_I2REF(X)       V_UNION(X, piVal)
#define V_I4(X)          V_UNION(X, lVal)
#define V_I4REF(X)       V_UNION(X, plVal)
#define V_R4(X)          V_UNION(X, fltVal)
#define V_R4REF(X)       V_UNION(X, pfltVal)
#define V_R8(X)          V_UNION(X, dblVal)
#define V_R8REF(X)       V_UNION(X, pdblVal)
#define V_I1(X)          V_UNION(X, cVal)
#define V_I1REF(X)       V_UNION(X, pcVal)
#define V_UI2(X)         V_UNION(X, uiVal)
#define V_UI2REF(X)      V_UNION(X, puiVal)
#define V_UI4(X)         V_UNION(X, ulVal)
#define V_UI4REF(X)      V_UNION(X, pulVal)
#define V_INT(X)         V_UNION(X, intVal)
#define V_INTREF(X)      V_UNION(X, pintVal)
#define V_UINT(X)        V_UNION(X, uintVal)
#define V_UINTREF(X)     V_UNION(X, puintVal)
#define V_CY(X)          V_UNION(X, cyVal)
#define V_CYREF(X)       V_UNION(X, pcyVal)
#define V_DATE(X)        V_UNION(X, date)
#define V_DATEREF(X)     V_UNION(X, pdate)
#define V_BSTR(X)        V_UNION(X, bstrVal)
#define V_BSTRREF(X)     V_UNION(X, pbstrVal)
#define V_DISPATCH(X)    V_UNION(X, pdispVal)
#define V_DISPATCHREF(X) V_UNION(X, ppdispVal)
#define V_ERROR(X)       V_UNION(X, scode)
#define V_ERRORREF(X)    V_UNION(X, pscode)
#define V_BOOL(X)        V_UNION(X, boolVal)
#define V_BOOLREF(X)     V_UNION(X, pboolVal)
#define V_UNKNOWN(X)     V_UNION(X, punkVal)
#define V_UNKNOWNREF(X)  V_UNION(X, ppunkVal)
#define V_VARIANTREF(X)  V_UNION(X, pvarVal)
#define V_ARRAY(X)       V_UNION(X, parray)
#define V_ARRAYREF(X)    V_UNION(X, pparray)
#define V_BYREF(X)       V_UNION(X, byref)

#define V_DECIMAL(X)     V_UNION(X, decVal)
#define V_DECIMALREF(X)  V_UNION(X, pdecVal)
*/

} //extern (Windows)
